var x1 u1 x2 u2 x3 u3 x4 u4 x5 u5 x6 u6 x7 u7 E gA 
    ax1 au1 ax2 au2 ax3 au3 ax4 au4 ax5 au5 ax6 au6 ax7 au7
    r1 r2 r3 r4 r5 r6 r7 
    lambda1 lambda2 lambda3 lambda4 lambda5 lambda6 lambda7 mu gamma
    ln_r1_tilde ln_r2_tilde ln_r3_tilde ln_r4_tilde ln_r5_tilde ln_r6_tilde
    ge_obs gx1_obs gx2_obs gx3_obs gx4_obs gx5_obs gx6_obs gx7_obs
    p;

varexo e_p e_A e_r1 e_r2 e_r3 e_r4 e_r5 e_r6 
       e_ax1 e_ax2 e_ax3 e_ax4 e_ax5 e_ax6 e_ax7
       e_r1_tilde e_r2_tilde e_r3_tilde e_r4_tilde e_r5_tilde e_r6_tilde;

parameters alph beta e delta N theta1 theta2 theta3 theta4 theta5 theta6 theta7
           ln_r1_bar ln_r2_bar ln_r3_bar ln_r4_bar ln_r5_bar ln_r6_bar ln_r7_bar
           ax1_bar au1_bar ax2_bar au2_bar ax3_bar au3_bar ax4_bar au4_bar 
           ax5_bar au5_bar ax6_bar au6_bar ax7_bar au7_bar
           sig2_11 sig2_12 sig2_13 sig2_14 sig2_15 sig2_16 sig2_17
           sig2_21 sig2_22 sig2_23 sig2_24 sig2_25 sig2_26 sig2_27
           sig2_31 sig2_32 sig2_33 sig2_34 sig2_35 sig2_36 sig2_37
           sig2_41 sig2_42 sig2_43 sig2_44 sig2_45 sig2_46 sig2_47
           sig2_51 sig2_52 sig2_53 sig2_54 sig2_55 sig2_56 sig2_57
           sig2_61 sig2_62 sig2_63 sig2_64 sig2_65 sig2_66 sig2_67
           sig2_71 sig2_72 sig2_73 sig2_74 sig2_75 sig2_76 sig2_77
           p11 p12 p13 p14 p15 p16 p21 p22 p23 p24 p25 p26 
           p31 p32 p33 p34 p35 p36 p41 p42 p43 p44 p45 p46
           p51 p52 p53 p54 p55 p56 p61 p62 p63 p64 p65 p66
           mean_xi_1 mean_xi_2 mean_xi_3 mean_xi_4 mean_xi_5 mean_xi_6 mean_xi_7
           gA0 p_bar; 
           
load param_bkl20160501model3estFL

set_param_value('alph',alph);   set_param_value('beta',beta); 
set_param_value('e',e);         set_param_value('N',N); 
set_param_value('delta',delta); set_param_value('gA0',gA0);     
set_param_value('p_bar',p_bar);

@#define indices = ["1", "2", "3", "4", "5", "6", "7"]
@#define indices2 = ["1", "2", "3", "4", "5", "6"]

@#for i in indices
    set_param_value('ln_r@{i}_bar',ln_r_bar(@{i}));
@#endfor
@#for i in indices
    set_param_value('ax@{i}_bar',ax_bar(@{i}));
@#endfor
@#for i in indices
    set_param_value('au@{i}_bar',au_bar(@{i}));
@#endfor
@#for i in indices
    set_param_value('theta@{i}',theta(@{i}));
@#endfor

@#for i in indices
    set_param_value('sig2_1@{i}',sig2(1,@{i}));
@#endfor
@#for i in indices
    set_param_value('sig2_2@{i}',sig2(2,@{i}));
@#endfor
@#for i in indices
    set_param_value('sig2_3@{i}',sig2(3,@{i}));
@#endfor
@#for i in indices
    set_param_value('sig2_4@{i}',sig2(4,@{i}));
@#endfor
@#for i in indices
    set_param_value('sig2_5@{i}',sig2(5,@{i}));
@#endfor
@#for i in indices
    set_param_value('sig2_6@{i}',sig2(6,@{i}));
@#endfor
@#for i in indices
    set_param_value('sig2_7@{i}',sig2(7,@{i}));
@#endfor
@#for i in indices2
    set_param_value('p1@{i}',psi(1,@{i}));
@#endfor
@#for i in indices2
    set_param_value('p2@{i}',psi(2,@{i}));
@#endfor
@#for i in indices2
    set_param_value('p3@{i}',psi(3,@{i}));
@#endfor
@#for i in indices2
    set_param_value('p4@{i}',psi(4,@{i}));
@#endfor
@#for i in indices2
    set_param_value('p5@{i}',psi(5,@{i}));
@#endfor
@#for i in indices2
    set_param_value('p6@{i}',psi(6,@{i}));
@#endfor
@#for i in indices
    set_param_value('mean_xi_@{i}',mean_xi(@{i}));
@#endfor

model;
// 1. Growth rate
    gA = exp(gA0 + e_A);
// 2-8. Payment rates of outstanding assets.
@#for i in indices
    ax@{i} = p*ax@{i}_bar*(1-mean_xi_@{i}-e_ax@{i})+(1-p)*ax@{i}_bar;
@#endfor
// 9-15. Payment rates of assets to be issued.
@#for i in indices
    au@{i} = p*au@{i}_bar*(1-mean_xi_@{i}-e_ax@{i})+(1-p)*au@{i}_bar;
@#endfor
// 16-22. Equation of state transition of outstanding loans.
@#for i in indices
    gA*x@{i} = ax@{i}*x@{i}(-1) + gA*u@{i};
@#endfor
// 23-29. FOC for the control variable u
@#for i in indices
    au@{i}*r@{i}-au@{i}*r@{i}*sqrt(theta@{i})*sqrt(theta1)*sig2_@{i}1*(ax1*r1(-1)*x1(-1)/gA+au1*r1*u1)-au@{i}*r@{i}*sqrt(theta@{i})*sqrt(theta2)*sig2_@{i}2*(ax2*r2(-1)*x2(-1)/gA+au2*r2*u2)-au@{i}*r@{i}*sqrt(theta@{i})*sqrt(theta3)*sig2_@{i}3*(ax3*r3(-1)*x3(-1)/gA+au3*r3*u3)-au@{i}*r@{i}*sqrt(theta@{i})*sqrt(theta4)*sig2_@{i}4*(ax4*r4(-1)*x4(-1)/gA+au4*r4*u4)-au@{i}*r@{i}*sqrt(theta@{i})*sqrt(theta5)*sig2_@{i}5*(ax5*r5(-1)*x5(-1)/gA+au5*r5*u5)-au@{i}*r@{i}*sqrt(theta@{i})*sqrt(theta6)*sig2_@{i}6*(ax6*r6(-1)*x6(-1)/gA+au6*r6*u6)-au@{i}*r@{i}*sqrt(theta@{i})*sqrt(theta7)*sig2_@{i}7*(ax7*r7(-1)*x7(-1)/gA+au7*r7*u7)+lambda@{i}*gA+e*mu*au@{i}*r@{i}*gA-gamma*gA=0;
@#endfor
// 30-36. FOC for the state variable x
@#for i in indices
    lambda@{i}*gA/beta=ax@{i}(+1)*r@{i}/gA(+1)-ax@{i}(+1)*r@{i}/gA(+1)*sqrt(theta@{i})*sqrt(theta1)*sig2_@{i}1*(ax1(+1)*r1*x1/gA(+1)+au1(+1)*r1(+1)*u1(+1))-ax@{i}(+1)*r@{i}/gA(+1)*sqrt(theta@{i})*sqrt(theta2)*sig2_@{i}2*(ax2(+1)*r2*x2/gA(+1)+au2(+1)*r2(+1)*u2(+1))-ax@{i}(+1)*r@{i}/gA(+1)*sqrt(theta@{i})*sqrt(theta3)*sig2_@{i}3*(ax3(+1)*r3*x3/gA(+1)+au3(+1)*r3(+1)*u3(+1))-ax@{i}(+1)*r@{i}/gA(+1)*sqrt(theta@{i})*sqrt(theta4)*sig2_@{i}4*(ax4(+1)*r4*x4/gA(+1)+au4(+1)*r4(+1)*u4(+1))-ax@{i}(+1)*r@{i}/gA(+1)*sqrt(theta@{i})*sqrt(theta5)*sig2_@{i}5*(ax5(+1)*r5*x5/gA(+1)+au5(+1)*r5(+1)*u5(+1))-ax@{i}(+1)*r@{i}/gA(+1)*sqrt(theta@{i})*sqrt(theta6)*sig2_@{i}6*(ax6(+1)*r6*x6/gA(+1)+au6(+1)*r6(+1)*u6(+1))-ax@{i}(+1)*r@{i}/gA(+1)*sqrt(theta@{i})*sqrt(theta7)*sig2_@{i}7*(ax7(+1)*r7*x7/gA(+1)+au7(+1)*r7(+1)*u7(+1))+lambda@{i}(+1)*ax@{i}(+1)+e*mu(+1)*ax@{i}(+1)*r@{i}-gamma(+1)*ax@{i}(+1);
@#endfor
// 37. FOC for equity as a state variable
    mu*gA/beta = mu(+1)*(1-delta)+gamma(+1)*N*alph*E^(alph-1);
// 38. Equation of state transition of equity
    E*gA = (1-delta)*E(-1)+e*((ax1*r1(-1)*x1(-1)+au1*r1*gA*u1)+(ax2*r2(-1)*x2(-1)+au2*r2*gA*u2)+(ax3*r3(-1)*x3(-1)+au3*r3*gA*u3)+(ax4*r4(-1)*x4(-1)+au4*r4*gA*u4)+(ax5*r5(-1)*x5(-1)+au5*r5*gA*u5)+(ax6*r6(-1)*x6(-1)+au6*r6*gA*u6)+(ax7*r7(-1)*x7(-1)+au7*r7*gA*u7));
// 39. Budget constraint
    N*E(-1)^alph = (ax1*x1(-1)+u1*gA)+(ax2*x2(-1)+u2*gA)+(ax3*x3(-1)+u3*gA)+(ax4*x4(-1)+u4*gA)+(ax5*x5(-1)+u5*gA)+(ax6*x6(-1)+u6*gA)+(ax7*x7(-1)+u7*gA);
// 40-46. Detrended VAR of rate of return
@#for i in indices2
    r@{i}-ln_r@{i}_tilde = p@{i}1*(r1(-1)-ln_r1_tilde(-1))+p@{i}2*(r2(-1)-ln_r2_tilde(-1))+p@{i}3*(r3(-1)-ln_r3_tilde(-1))+p@{i}4*(r4(-1)-ln_r4_tilde(-1))+p@{i}5*(r5(-1)-ln_r5_tilde(-1))+e_r@{i};
@#endfor
    r7=ln_r7_bar;
// 47-52. Mean value of rate of return
@#for i in indices2
    ln_r@{i}_tilde = ln_r@{i}_bar + e_r@{i}_tilde;
@#endfor
// 53. Growth rate of observed total assets
    ge_obs = gA*E/E(-1);
// 54-60. Growth rate of observed outstanding assets.
@#for i in indices
   gx@{i}_obs = gA*x@{i}/x@{i}(-1);
@#endfor
// 61. Disaster probability
    p = p_bar + e_p;
end;

// varobs ge_obs gx1_obs gx2_obs gx3_obs gx4_obs gx5_obs;
/*
initval;
x1	=	1820411.73392735	;
u1	=	183416.207947553	;
x2	=	841966.601533818	;
u2	=	237872.048937346	;
x3	=	665429.176929496	;
u3	=	386111.975342180	;
x4	=	3466960.84116013	;
u4	=	234550.713183258	;
x5	=	1481608.45616639	;
u5	=	264252.384171506	;
x6	=	-8665549.39325472	;
u6	=	-1011477.64936644	;
x7	=	389552.241822658	;
u7	=	5799.67730401803	;
E	=	7826.49993122599	;
gA          	=	1.01511306461572	;
ax1         	=	0.912835000000000	;
au1         	=	0.922460000000000	;
ax2         	=	0.728323750000000	;
au2         	=	0.737948750000000	;
ax3         	=	0.426098750000000	;
au3  	=	0.435723750000000	;
ax4         	=	0.946437500000000	;
au4         	=	0.956400000000000	;
ax5         	=	0.834062500000000	;
au5         	=	0.843875000000000	;
ax6         	=	0.896625000000000	;
au6         	=	0.906587500000000	;
ax7         	=	1	;
au7         	=	1	;
r1          	=	0.0852013470262306	;
r2          	=	0.0827078807292447	;
r3          	=	0.101922181446553	;
r4          	=	0.0235893707769170	;
r5          	=	0.0245259306871528	;
r6          	=	0.0196668233557975	;
r7          	=	0	;
lambda1	=	3.93208057924367e-18	;
lambda2	=	-1.25313830098869e-17	;
lambda3	=	-4.50813303742460e-18	;
lambda4	=	2.08957671004068e-18	;
lambda5	=	9.39695492845611e-18	;
lambda6	=	-1.07779022737876e-17	;
lambda7	=	0	;
mu	=	-3.15544362088405e-30	;
gamma	=	0	;
ln_r1_tilde 	=	0.0852013470262306	;
ln_r2_tilde 	=	0.0827078807292447	;
ln_r3_tilde 	=	0.101922181446553	;
ln_r4_tilde 	=	0.0235893707769170	;
ln_r5_tilde 	=	0.0245259306871528	;
ln_r6_tilde 	=	0.0196668233557975	;
ge_obs      	=	1.01511306461572	;
gx1_obs     	=	1.01511306461572	;
gx2_obs     	=	1.01511306461572	;
gx3_obs     	=	1.01511306461572	;
gx4_obs     	=	1.01511306461572	;
gx5_obs     	=	1.01511306461572	;
gx6_obs     	=	1.01511306461572	;
gx7_obs     	=	1.01511306461572	;
p           	=	0.375	;
end;
*/

shocks; // This shock block is mainly for forecastable shock
var e_ax1; stderr 0.1;
end;

// Check that this is indeed the steady state
steady(maxit = 100);
//model_diagnostics(M_,options_,oo_)

// Check the Blanchard-Kahn conditions
check;

/*
shocks; // This shock block is mainly for stochastic shock.
//var e_ax1;
//periods 2;
//values 0.1;
//var e_ax1; stderr 0.1;
var e_r1; stderr 0.003;
corr e_ax1, e_ax2 = 1;
corr e_ax1, e_ax3 = 1;
corr e_ax1, e_ax4 = -0.5;
corr e_ax1, e_ax5 = 1;
corr e_ax2, e_ax3 = 1;
corr e_ax2, e_ax4 = -0.5;
corr e_ax3, e_ax4 = -0.5;
corr e_ax1, e_r1 = 1;
corr e_ax2, e_r2 = 1;
corr e_ax3, e_r3 = 1;
corr e_ax4, e_r4 = 0.5;
corr e_ax5, e_r5 = 0.5;
end;
*/

 
// Deterministic simulation of the model for 200 periods
//simul(periods = 30);
stoch_simul;

// Display the path of consumption and capital
//rplot x1 x2 x3 x4 x5 u1 u2 u3 u4 u5 r1 r2 r3 r4 r5 Y E;
/*
estimated_params;
alph, beta_pdf, 0.33, 0.05;
beta, beta_pdf, 0.99, 0.005; 
//e, uniform_pdf, , , 0,086;
N, normal_pdf, 15, 5;
gA0, beta_pdf, 0.015, 0.005;
//delta, beta_pdf, 0.01, 0.005;

theta1, gamma_pdf, 1666, 50; // 4
theta2, gamma_pdf, 1250, 50; // 3
theta3, gamma_pdf, 1666, 50; // 4
theta4, gamma_pdf, 71, 1; // 8
theta5, gamma_pdf, 55, 1; // 8

mean_xi_1, beta_pdf, 0.1, 0.05;
mean_xi_2, beta_pdf, 0.1, 0.05;
mean_xi_3, beta_pdf, 0.1, 0.05;
mean_xi_4, beta_pdf, 0.001, 0.0005;
mean_xi_5, beta_pdf, 0.01, 0.005;

stderr e_A, inv_gamma_pdf, 0.03, inf;

stderr e_r1, inv_gamma_pdf, 0.3, inf;
stderr e_r2, inv_gamma_pdf, 0.3, inf;
stderr e_r3, inv_gamma_pdf, 0.3, inf;
stderr e_r4, inv_gamma_pdf, 0.3, inf;
stderr e_r5, inv_gamma_pdf, 0.3, inf;

stderr e_ax1, inv_gamma_pdf, 0.5, inf;
stderr e_ax2, inv_gamma_pdf, 0.5, inf;
stderr e_ax3, inv_gamma_pdf, 5, inf;
stderr e_ax4, inv_gamma_pdf, 20, inf;
stderr e_ax5, inv_gamma_pdf, 20, inf;

stderr e_r1_tilde, inv_gamma_pdf, 0.03, inf;
stderr e_r2_tilde, inv_gamma_pdf, 0.03, inf;
stderr e_r3_tilde, inv_gamma_pdf, 0.03, inf;
stderr e_r4_tilde, inv_gamma_pdf, 0.03, inf;
stderr e_r5_tilde, inv_gamma_pdf, 0.03, inf;

end;


estimation(order=1, datafile=bkl20160501model3dataFL, nobs=44, loglinear, mh_replic=2000, mh_nblocks=10, mh_jscale=0.8,mode_compute=9,mode_check,diffuse_filter);
*/